//---------------------------------------------------------------------------

#ifndef FourCCGUIH
#define FourCCGUIH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include "CSPIN.h"
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include "CGAUGES.h"
#include <DdeMan.hpp>

class MapGraph;
class RelaxtionThread;
//---------------------------------------------------------------------------
class TForm_4CC : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel_Top;
        TPanel *Panel_Right;
        TPanel *Panel_Bottom;
        TPanel *Panel_Left;
        TScrollBox *ScrollBox_Unlimited_Canvas;
        TImage *Image_Map;
        TSpeedButton *SpeedButton_Clear;
        TSpeedButton *SpeedButton_Load;
        TSpeedButton *SpeedButton_Save;
        TGroupBox *GroupBox_MatrixSettings;
        TCSpinEdit *CSpinEdit_MapWidth;
        TLabel *L_MapWidthCap;
        TLabel *L_MapHeightCap;
        TCSpinEdit *CSpinEdit_MapHeight;
        TShape *Shape_BGColorSelection;
        TShape *Shape_GridColorSelection;
        TShape *Shape_Pixel;
        TLabel *L_NoteApply;
        TLabel *L_GridSizeCap;
        TCSpinEdit *CSpinEdit_PixelSize;
        TOpenPictureDialog *OpenPictureDialog;
        TImage *Image_Temp;
        TSavePictureDialog *SavePictureDialog;
        TColorDialog *ColorDialog;
        TSpeedButton *SpeedButton_Color;
        TGroupBox *GroupBox_penMode;
        TSpeedButton *SpeedButton_DrawMode;
        TSpeedButton *SpeedButton_SelectMode;
        TTimer *Timer_RestoreSelectedContry;
        TGroupBox *GroupBox_Statistics;
        TLabel *L_Contries;
        TLabel *L_NumberOfVertices;
        TShape *Shape_BaseColorOfRegion;
        TListView *ListView_Regions;
        TLabel *L_Regions;
        TImageList *ImageList_RegionsColors;
        TSpeedButton *SpeedButton_ZoomIn;
        TSpeedButton *SpeedButton_ZoomOut;
        TMemo *Memo_Instructions;
        TLabel *L_NumberOfIterationCaption;
        TLabel *L_NumberOfIteration;
        TSpeedButton *SpeedButton_Start;
        TSpeedButton *SpeedButton_Pause;
        TGroupBox *GroupBox_RegionInfo;
        TLabel *L_RegionIDCaption;
        TLabel *L_RegionID;
        TLabel *L_NeighborsListCaption;
        TLabel *L_NeighborsList;
        TLabel *L_Probabilities;
        TCGauge *CGauge_Color1;
        TCGauge *CGauge_Color2;
        TCGauge *CGauge_Color3;
        TCGauge *CGauge_Color4;
        TTimer *Timer_DisplayProgress;
        TComboBox *ComboBox_RelaxtionSelection;
        TLabel *L_ChooseRelaxtionModel;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *L_AmbiguousCount;
        TLabel *L_unambiguousCount;
        void __fastcall SpeedButton_ClearClick(TObject *Sender);
        void __fastcall CSpinEdit_PixelSizeChange(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall Image_MapMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall Image_MapMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image_MapMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall SpeedButton_LoadClick(TObject *Sender);
        void __fastcall SpeedButton_SaveClick(TObject *Sender);
        void __fastcall SpeedButton_ColorClick(TObject *Sender);
        void __fastcall SpeedButton_DrawModeClick(TObject *Sender);
        void __fastcall OnMouseSelect(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall SpeedButton_SelectModeClick(TObject *Sender);
        void __fastcall Timer_RestoreSelectedContryTimer(TObject *Sender);
        void __fastcall SpeedButton_ZoomInClick(TObject *Sender);
        void __fastcall SpeedButton_ZoomOutClick(TObject *Sender);
        void __fastcall SpeedButton_StartClick(TObject *Sender);
        void __fastcall SpeedButton_PauseClick(TObject *Sender);
        void __fastcall ListView_RegionsChange(TObject *Sender,
          TListItem *Item, TItemChange Change);
        void __fastcall Timer_DisplayProgressTimer(TObject *Sender);
        void __fastcall ComboBox_RelaxtionSelectionChange(TObject *Sender);
private:
        int m_currGridWidth;
        int m_currGridHeight;
        int m_lastPaintX;
        int m_lastPaintY;
        int m_oldColor;
        int *m_colorRemapTable;
        int **m_matrix;
        int m_pixelSize;
        MapGraph* m_mapGraph;
        void repaintGrid();
        void drawMatrix();
        void updateRegionsDisplay();
        TMouseButton m_buttonPressed;
        RelaxtionThread* m_relaxtionThread;
        static const int defaultColorsTable[];
        static const int defaultColorsTableSize;
        static int makeSelectionColor(int col);

public:		// User declarations
        __fastcall TForm_4CC(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm_4CC *Form_4CC;
//---------------------------------------------------------------------------
#endif
