//---------------------------------------------------------------------------

#ifndef MapGraphH
#define MapGraphH

#include <system.hpp>

class MapGraph{
 private:
  bool** m_neighborsMatrix;
  double** m_vertexColorProbability;
  int m_vertexCount;

  int** m_graphicMatrix;
  int m_graphcWidth;
  int m_graphcHeight;
  int m_wantedColorsCount;
  static const int MAX_BOARDER_WIDTH;

  void recognizeNeighbors();
  void assignNeighbors(int n1,int n2);

 public:
   MapGraph(int **graphicDrawnMap,int width,int height,int wantedColorsCount=4);

   ~MapGraph();

   int vertexCount();
   void setVertexColorProbability(int vertexID,int color,double prob);
   double getVertexColorProbability(int vertexID,int color);
   void updateDisplayColors(int **graphicDrawnMap,int* colorTable);
   //This proc re-maps the colors !=-1 of m_graphicMatrix to other display matrix
   //Note: graphicDrawnMap is changed!!!

   void restoreDisplayColors(int **graphicDrawnMap,int borderColor);
   //Note: graphicDrawnMap is changed!!!
   AnsiString neighborsOfVertex(int vertex);
   int getVertexOnGraphicXY(int x,int y);
   int getWantedColorsCount();
   bool isNeighbors(int n1,int n2);

};

//---------------------------------------------------------------------------
#endif
